# UnionNode

class xsdata.formats.dataclass.parsers.nodes.UnionNode(var, attrs, ns_map, position, config, context)

  XmlNode for fields with multiple possible types where at least one of them is a dataclass.

  The node will record all child events and in the end will replay them and try to build all possible objects and sort them by score before deciding the winner.

  Parameters

    - var (`XmlVar`) – Class field xml var instance

    - attrs (`Dict`) – Key-value attribute mapping

    - ns_map (`Dict`) – Namespace prefix-URI map

    - position (`int`) – The node position of objects cache

    - config (`ParserConfig`) – Parser configuration

    - context (`XmlContext`) – Model context provider

  child(qname, attrs, ns_map, position)

    Initialize the next child node to be queued, when a new xml element starts.

    This entry point is responsible to create the next node type with all the necessary information on how to bind the incoming input data.

    Parameters

      - qname (`str`) – Qualified name

      - attrs (`Dict`) – Attribute key-value map

      - ns_map (`Dict`) – Namespace prefix-URI map

      - position (`int`) – The current objects position, to mark future objects as children

    Return type

      `XmlNode`

  bind(qname, text, tail, objects)

    Build the object tree for the ending element and return whether the result was successful or not.

    This entry point is called when an xml element ends and is responsible to parse the current element attributes/text, bind any children objects and initialize new object.

    Parameters

      - qname (`str`) – Qualified name

      - text (`Optional`[`str`, `None`]) – Text content

      - tail (`Optional`[`str`, `None`]) – Tail content

      - objects (`List`) – The list of intermediate parsed objects, eg [(qname, object)]

    Return type

      `bool`

  parse_class(clazz)

    Initialize a new XmlParser and try to parse the given element, treat converter warnings as errors and return None.

    Return type

      `Optional`[~T, `None`]

  parse_value(value, types)

    Parse simple values, treat warnings as errors and return None.

    Return type

      `Any`